<template>

    <!--

    result

    ---------------------------------------------------------- -->
    <div id='results' class='swiper-slide selection-question results' data-hash='Q7'
            v-bind:class="{  visible: isResults}" >
        <div class='outer'>
            <section class='main'>
                <h1>The results are in.</h1>
                <p style='color:#747474'>
                    Based on the answers you've provided, here's the Dahle shredder that will best fit your needs. Click on the model below to learn more.
                </p>
                <div id='top-shredders'>
                    <div class="top-left-side">
                        <a target="_blank" :href="topResultUrl" class="button has-figure">
                            <span class="button-caption">{{topResult.model}}</span>
                            <span class="button-figure is-shredder"
                                  :style="{backgroundImage: `url(${picUrl(topResult)})`}"></span>
                        </a></div>
                    <div class="top-right-side">
                        <h3>{{topResult.model}} Shredder</h3>
                        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip...</p>
                        <div>
                            <a :href="topResultUrl" class="learn-more" target="_blank">
                                Learn More<span class="more-arrow"></span>
                            </a>
                        </div>
                        <div class="more-suggestions">Additional recommendations...</div>
                        <a v-for="s in others" v-bind:key="s.model" target="_blank" :href="url(s)" class="button has-figure">
                            <span class="button-caption">{{s.model}}</span>
                            <span class="button-figure is-shredder"
                                  :style="{backgroundImage: `url(${picUrl(s)})`}"></span>
                        </a>
                    </div>
                </div>
            </section>
            <aside class='questions-answers'>
                <ul id='questions-answers'>
                    <li class='q-a'>
                        <h3 class='question'>Where will the shredder be used?</h3>
                        <label class='selector'>
                            <select id='selector-1' class='select-button' v-model="location">
                                <option value='home'>Home</option>
                                <option value='biz'>Business</option>
                                <option value='gov'>Government</option>
                            </select>
                        </label>
                    </li>
                    <li class='q-a'>
                        <h3 class='question'>How often will you shred?</h3>
                        <label class='selector'>
                            <select id='selector-2' class='select-button'  v-model="frequency">
                                <option value='daily'>Daily</option>
                                <option value='weekly'>Weekly</option>
                                <option value='monthly'>Monthly</option>
                                <option value='quarterly'>Quarterly</option>
                            </select>
                        </label>
                    </li>
                    <li class='q-a'>
                        <h3 class='question'>How much material do you plan to shred per day?</h3>
                        <label class='selector'>
                            <select id='selector-3' class='select-button' v-model="capacity">
                                <option value='0-1k'>Less than 1k</option>
                                <option value='1k-4k'>Between 1k&mdash;4k</option>
                                <option value='4k-8k'>Between 4k&mdash;8k</option>
                                <option value='8k-12k'>Between 8k&mdash;12k</option>
                                <option value='12k+'>More than 12k</option>
                            </select>
                        </label>
                    </li>
                    <li class='q-a'>
                        <h3 class='question'>How many people will use the shredder?</h3>
                        <label class='selector'>
                            <select id='selector-4' class='select-button' v-model="users">
                                <option value='1'>1 Person</option>
                                <option value='3'>1&mdash;3 People</option>
                                <option value='5'>3&mdash;5 People</option>
                                <option value='5+'>5+ People</option>
                            </select>
                        </label>
                    </li>
                    <li class='q-a'>
                        <h3 class='question'>Would you like a fine dust filter system?</h3>
                        <label class='selector'>
                            <select id='selector-5' class='select-button' v-model="cleanTech">
                                <option value='yes'>Yes</option>
                                <option value='no'>No</option>
                            </select>
                        </label>
                    </li>
                    <li class='q-a'>
                        <h3 class='question'>What level of security do you require?</h3>
                        <label class='selector'>
                            <select id='selector-6' class='select-button' v-model="security">
                                <option value='P2'>P2 &mdash; Low</option>
                                <option value='P3'>P3 &mdash; Basic</option>
                                <option value='P4'>P4 &mdash; Standard</option>
                                <option value='P5'>P5 &mdash; Greater</option>
                                <option value='P6'>P6 &mdash; Advanced</option>
                                <option value='P7'>P7 &mdash; Extreme</option>
                            </select>
                        </label>
                    </li>
                </ul>
            </aside>
        </div>
    </div>
</template>

<script>
  import { mapGetters, mapMutations } from 'vuex'

  export default {
    name: 'Results',

    computed: {
      ...mapGetters(['isResults', 'results', 'answers']),

      topResult() {
        return this.results[0];
      },

      others() {
        return this.results.slice(1, 3);
      },

      topResultUrl(){
        return "https://www.dahle.com/product/shredder/" + this.topResult.model.replace(' ','').toLowerCase();
      },

      picUrl(){
        return shredder => `https://www.dahle.com/feeds/dahle_asset_feed/${shredder.model.replace(' ','_')}_01.jpg`;
      },

      url() {
        return shredder => "https://www.dahle.com/product/shredder/" + shredder.model.replace(' ','').toLowerCase();
      },

      //Answers:

      location: {
        get() {
          return this.answers.location;
        },

        set(val) {
          this.setLocation(val);
        },
      },


      frequency: {
        get() {
          return this.answers.frequency;
        },

        set(val) {
          this.setFrequency(val);
        },
      },


      capacity: {
        get() {
          return this.answers.capacity;
        },

        set(val) {
          this.setCapacity(val);
        },
      },


      users: {
        get() {
          return this.answers.users;
        },

        set(val) {
          this.setUsers(val);
        },
      },


      cleanTech: {
        get() {
          return this.answers.cleanTech;
        },

        set(val) {
          this.setCleanTech(val);
        },
      },


      security: {
        get() {
          return this.answers.security;
        },

        set(val) {
          this.setSecurity(val);
        },
      },

    },

    methods: {
      ...mapMutations(['goto', 'setLocation', 'setFrequency', 'setCapacity', 'setUsers', 'setCleanTech', 'setSecurity'])
    }
  }
</script>